<?php
/*
 * Plugin Name: myglobalHOST Security Booster
 * Plugin URI: https://www.myglobalhost.net/
 * Author: myglobalHOST
 * Author URI: https://www.myglobalhost.in/
 * Description: This plugin protects your wordpress website from Malicious Requests & Bad Bots. Simply upload, activate and forget!. The rest will be taken care by the plugin automatically.
 * Version: 1.0
 * Text Domain: myglobalHOST
 */

// Protect Your Site from Malicious Requests
 global $user_ID; if($user_ID) {
    if(!current_user_can('administrator')) {
        if (strlen($_SERVER['REQUEST_URI']) > 255 ||
            stripos($_SERVER['REQUEST_URI'], "eval(") ||
            stripos($_SERVER['REQUEST_URI'], "CONCAT") ||
            stripos($_SERVER['REQUEST_URI'], "UNION+SELECT") ||
            stripos($_SERVER['REQUEST_URI'], "base64")) {
                @header("HTTP/1.1 414 Request-URI Too Long");
                @header("Status: 414 Request-URI Too Long");
                @header("Connection: Close");
                @exit;
        }
    }
}

// Protection Against Super Bad Bots
function stop_bad_bots() {
    $bad_user_agents = array(
        'yandex', 'applebot', 'bingbot', 'virusbot', 'spambot', 'evilbot', 'acunetix', 'BLEXBot', 'domaincrawler', 'LinkpadBot', 'MJ12bot', 'majestic12', 'AhrefsBot', 'TwengaBot', 'SemrushBot', 'nikto', 'winhttp', 'Xenu', 'Sleuth', 'Baiduspider', 'HTTrack', 'clshttp', 'harvest', 'extract', 'grab', 'miner', 'python-requests', 'coccocbot-image', 'Baiduspider', 'DotBot', 'AlphaBot', 'ZoominfoBot', 'ADmantX', 'rogerbot', 'BLEXBot', 'SeznamBot', 'ZumBot', 'MaxPointCrawler', 'Nutch', 'Buzzbot', 'DataForSeoBot', 'ZoominfoBot', 'SeekportBot', 'CCBot', 'serpstatbot', 'thesis-research-bot', 'my-tiny-bot', 'fidget-spinner-bot', 'AwarioBot', 'CriteoBot', 'Bytespider', 'SEOkicks', 'ImagesiftBot', 'PetalBot', 'proximic', 'peer39_crawler', 'panscient.com', 'crepyBot', 'Barkrowler', 'nbot', 'Sogou', 'bidswitchbot', 'DuckDuckGo-Favicons-Bot', 'DuckDuckGo', 'GrapeshotCrawler', 'MojeekBot', 'DomainStatsBot', 'SurdotlyBot', 'Konqueror', 'CFNetwork', 'scrapy', 'OVH', 'colocrossing', 'microsoft', 'Wowrack', // Add more as needed
    );

    foreach ($bad_user_agents as $agent) {
        if (stripos($_SERVER['HTTP_USER_AGENT'], $agent) !== false) {
            wp_die('Access denied.'); // Or redirect to a 403 page
        }
    }
}

add_action('init', 'stop_bad_bots');

// Protection against xmlrpc hacking
add_filter('xmlrpc_enabled', '__return_false');

// Stop Block Author Scans
function disable_author_archives() {
    global $wp_query;
    if (is_author()) {
        $wp_query->set_404();
        status_header(404);
    }
}
add_action('template_redirect', 'disable_author_archives');


// Block access to wp-trackback.php
function d() {
    if (strpos($_SERVER['REQUEST_URI'], 'wp-trackback.php') !== false) {
        wp_die('Trackbacks are disabled on this site.'); 
    }
}
add_action('init', 'd');

// Block access to wp-config.php
function e() {
    if (strpos($_SERVER['REQUEST_URI'], 'wp-config.php') !== false) {
        wp_die('Access denied.'); 
    }
}
add_action('init', 'e');
